Bug 451496 - bittorrent tracker fails to track (with traceback)
bittorrent tracker fails to track (with traceback)
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: bittorrent (Show other bugs)
10
All Linux
high Severity high
: ---
: ---
Assigned To: Paul Howarth
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-06-14 20:00 EDT by Jeroen van Meeuwen
Modified: 2009-10-27 03:06 EDT (History)
2 users (show)

See Also:
Fixed In Version: 4.4.0-12.fc10
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-10-27 03:06:50 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Fix bug with error: KeyError: <type 'float'> (1.95 KB, patch)
2009-04-01 16:13 EDT, Oleg Aprotskiy
no flags Details | Diff

  None (edit)
Description Jeroen van Meeuwen 2008-06-14 20:00:55 EDT
Description of problem:

bittorrent tracker fails with a traceback (from /var/lob/bittorrent/bttrack.log):

Traceback (most recent call last):
  File "/usr/lib/python2.5/site-packages/BitTorrent/RawServer_twisted.py", line
418, in _make_wrapped_call
    function(*args)
  File "/usr/lib/python2.5/site-packages/BitTorrent/HTTPHandler.py", line 187,
in data_came_in
    if not c.data_came_in(data) and not c.closed:
  File "/usr/lib/python2.5/site-packages/BitTorrent/HTTPHandler.py", line 52, in
data_came_in
    self.next_func = self.next_func(val)
  File "/usr/lib/python2.5/site-packages/BitTorrent/HTTPHandler.py", line 96, in
read_header
    r = self.handler.getfunc(self, self.path, self.headers)
  File "/usr/lib/python2.5/site-packages/BitTorrent/track.py", line 735, in get
    rsize = self.add_data(infohash, event, ip, paramslist)
  File "/usr/lib/python2.5/site-packages/BitTorrent/track.py", line 563, in add_data
    NatCheck(self.connectback_result,infohash,myid,ip1,port,self.rawserver)
  File "/usr/lib/python2.5/site-packages/BitTorrent/NatCheck.py", line 33, in
__init__
    rawserver.async_start_connection((ip, port), self)
  File "/usr/lib/python2.5/site-packages/BitTorrent/RawServer_twisted.py", line
724, in async_start_connection
    if (len(self.pending_sockets) >= self.config['max_incomplete'] and
KeyError: 'max_incomplete'

Version-Release number of selected component (if applicable):

bittorrent-4.4.0-6.fc8

How reproducible:

Start bttrack service

Actual results:

Traceback as described, clients cannot connect, tracking fails

Expected results:

Tracking

Additional info:

Simply commenting out the three lines in
/usr/lib/python2.5/site-packages/BitTorrent/RawServer_twisted.py (line 724-726)
fixes the problem
Comment 1 Paul Howarth 2008-08-08 12:33:37 EDT
I'm struggling to reproduce this problem. Can you tell me:

Which python-twisted-* packages you have installed (if any)?
$ rpm -qa python-twisted-\*

Is there a .bittorrent directory in the torrent user's home directory, and if so, what is in the config files that live there?

What do you have in /etc/sysconfig/bittorrent ?
Comment 2 Lev Shamardin 2008-08-15 05:59:02 EDT
Fedora 8, bittorrent-4.4.0-6.fc8, python-twisted-core-2.5.0-2.fc8

Works fine with TRACKOPTS="--min_time_between_log_flushes 4.0 --show_names 1 --hupmonitor 1 --allow_get 0 --twisted 1 --bind 10.10.200.1" in /etc/sysconfig/bittorrent

But on my production server it has --twisted 0, and as far as I remember I did have this issue some time ago, and that was the reason why I disabled twisted in production. May be this issue is gone now after some updates.
Comment 3 Paul Howarth 2008-10-08 11:18:05 EDT
Jeroen, can you still reproduce this?
Comment 4 Jeroen van Meeuwen 2008-10-13 07:47:33 EDT
I still have the three-line patch applied so I cannot "just" reproduce this without interrupting service...

I am seeing another traceback occur that has less impact though:

Traceback (most recent call last):
  File "/usr/lib/python2.5/site-packages/BitTorrent/RawServer_twisted.py", line 418, in _make_wrapped_call
    function(*args)
  File "/usr/lib/python2.5/site-packages/BitTorrent/track.py", line 796, in save_dfile
    h.write(bencode(self.state))
  File "/usr/lib/python2.5/site-packages/BitTorrent/bencode.py", line 135, in bencode
    encode_func[type(x)](x, r)
  File "/usr/lib/python2.5/site-packages/BitTorrent/bencode.py", line 115, in encode_dict
    encode_func[type(v)](v, r)
  File "/usr/lib/python2.5/site-packages/BitTorrent/bencode.py", line 115, in encode_dict
    encode_func[type(v)](v, r)
  File "/usr/lib/python2.5/site-packages/BitTorrent/bencode.py", line 106, in encode_list
    encode_func[type(i)](i, r)
  File "/usr/lib/python2.5/site-packages/BitTorrent/bencode.py", line 106, in encode_list
    encode_func[type(i)](i, r)
KeyError: <type 'float'>
Comment 5 Paul Howarth 2008-10-13 08:29:19 EDT
Looks like a similar issue, config items not found. Could you tell me what versions of python-twisted-* packages you have, what, if anything, you have in /etc/sysconfig/bittorrent and what, if anything there is inside ~torrent/.bittorrent ?
Comment 6 Jeroen van Meeuwen 2008-10-14 06:48:50 EDT
[jmeeuwen@bofh002 ~]$ rpm -qa python-twisted*
python-twisted-core-2.5.0-2.fc8
python-twisted-web-0.7.0-1.fc8
[jmeeuwen@bofh002 ~]$ cat /etc/sysconfig/bittorrent
SEEDDIR=/data/bittorrent
SEEDOPTS="--bind 143.121.192.153 --ip 143.121.192.153 --max_upload_rate 0 --display_interval 15 --torrent_dir /data/bittorrent/"
SEEDLOG=/var/log/bittorrent/btseed.log
TRACKPORT=6969
TRACKDIR=/srv/bittorrent/data
TRACKSTATEFILE=/srv/bittorrent/state/bttrack
TRACKLOG=/var/log/bittorrent/bttrack.log
TRACKOPTS="--bind 143.121.192.153 --port 6969 --min_time_between_log_flushes 4.0 --show_names 1 --hupmonitor 1 --allow_get 0 --allowed_dir /srv/bittorrent/data/"
[jmeeuwen@bofh002 ~]$ sudo ls -lR ~torrent/.bittorrent/
/var/lib/bittorrent/.bittorrent/:
total 8
drwx------ 4 torrent torrent 4096 2008-06-04 00:36 data

/var/lib/bittorrent/.bittorrent/data:
total 36
drwx------ 2 torrent torrent  4096 2008-06-04 00:35 metainfo
drwx------ 2 torrent torrent  4096 2008-10-12 14:58 resume
-rw-r--r-- 1 torrent torrent 14267 2008-10-14 12:43 routing_table

/var/lib/bittorrent/.bittorrent/data/metainfo:
total 0

/var/lib/bittorrent/.bittorrent/data/resume:
total 804
-rw-r--r-- 1 torrent torrent 12389 2008-10-01 04:24 0dcc938159a4cac0a0cdc73570c6ed0802cdac9c
-rw-r--r-- 1 torrent torrent 14769 2008-10-05 01:34 125a04115df577dadeea9d0ba0777379eeeebd1d
-rw-r--r-- 1 torrent torrent    50 2008-09-20 18:31 12f4c5237365a272a894b2814b5bfe579db5fc5d
-rw-r--r-- 1 torrent torrent 14401 2008-10-01 04:24 15ce6bd1cb010e341e33ad15940c61a0dbd563ff
-rw-r--r-- 1 torrent torrent    50 2008-09-20 23:27 17e692f45b0d462e7fcf8a16b0346cf68db4b864
-rw-r--r-- 1 torrent torrent  5650 2008-07-22 16:46 1d379cf0278828f6788ffd6fa096b6ad2f373ef7
-rw-r--r-- 1 torrent torrent  2543 2008-10-01 04:24 1e0ce6ba5356a8bdd7b698d48d3f22a4b87a0023
-rw-r--r-- 1 torrent torrent 12686 2008-10-01 04:24 27351fde3d7a221bd2d5363d08d1506e152cca0f
-rw-r--r-- 1 torrent torrent 30308 2008-07-22 16:46 28596a9bbfb377dd5b01d69fa1762246aaefc650
-rw-r--r-- 1 torrent torrent    50 2008-09-20 23:27 2a517d947503531ef50ad1ebe52b4cb332ff70ab
-rw-r--r-- 1 torrent torrent 14490 2008-10-01 04:24 358368f5961886da537a5bbb18aea15c440c42bb
-rw-r--r-- 1 torrent torrent 12435 2008-10-01 04:24 38199b4d5004d89f0ded00065213e6c9063c7927
-rw-r--r-- 1 torrent torrent  5642 2008-10-12 14:58 4c66aca5f73d559a2f9392587a6d58990ec62fd2
-rw-r--r-- 1 torrent torrent 14380 2008-10-01 04:24 580eb6b2bc1c983b780736fecb427d7f781cc248
-rw-r--r-- 1 torrent torrent 16793 2008-10-01 04:24 5ebdd52fd75f628864da538bd4d45a993c406b73
-rw-r--r-- 1 torrent torrent 17265 2008-10-05 01:26 602ff37ed21eb0e4f699226fb120015fdb1bdd54
-rw-r--r-- 1 torrent torrent    50 2008-09-20 18:31 6d6da012e4583a2e00a209f6ad049ac8b4f0a86c
-rw-r--r-- 1 torrent torrent 28715 2008-08-14 20:30 712bc1edde9919cdcef743104a50c93938d604da
-rw-r--r-- 1 torrent torrent  5692 2008-10-12 14:56 7540ef59d6a4baa01e2e9b08683a7a321635a367
-rw-r--r-- 1 torrent torrent 31856 2008-07-22 16:46 754ea5e1ee02e32d9646f0d5b6c865e2805a7a99
-rw-r--r-- 1 torrent torrent 14739 2008-10-01 04:24 78ad62519ed24d1d893a68ea56266503000cad63
-rw-r--r-- 1 torrent torrent 14568 2008-10-01 04:24 83be2740f20ea3df2bed7a474b8aef8d9f05246a
-rw-r--r-- 1 torrent torrent  2843 2008-10-01 04:24 898aa7b616d1d8b0296586651d00230b6ce43c05
-rw-r--r-- 1 torrent torrent 25319 2008-08-14 20:30 8ab4d70f5f4d017a77ec955aad70eec89438028d
-rw-r--r-- 1 torrent torrent 15629 2008-10-01 04:24 8ae9dedf520e7edc46fce6e41902f88250fcd586
-rw-r--r-- 1 torrent torrent 16861 2008-10-05 01:18 8b09de32cdbd3ee1d011f87cf05d56536718bf69
-rw-r--r-- 1 torrent torrent  2477 2008-10-01 04:24 8be3a09eb054154c94bdeb5c3d7d935fe1770c93
-rw-r--r-- 1 torrent torrent  2340 2008-09-20 17:45 8d3b492fde8e36ff929e5a113c1d2194d53c2a46
-rw-r--r-- 1 torrent torrent 24781 2008-08-14 20:30 99a16ca5b367a034c929fc1475f65f612d8660da
-rw-r--r-- 1 torrent torrent 12703 2008-10-01 04:24 a2cd038ddb492803dee9ad0b5a891ccc40428529
-rw-r--r-- 1 torrent torrent 14904 2008-10-01 04:24 a634149ae2bcdafcb1b8afb1f79b4206c35c3c44
-rw-r--r-- 1 torrent torrent  5624 2008-10-12 14:50 ad46268a785edd09874c7e67fd98355d35d89603
-rw-r--r-- 1 torrent torrent 27522 2008-07-22 16:45 b735039bf036dfa158281474a225ea54dd816138
-rw-r--r-- 1 torrent torrent 30410 2008-07-22 16:46 b7e58a5e7a3aa58fdbadb4d6838c0fea32501e12
-rw-r--r-- 1 torrent torrent 31987 2008-07-22 16:45 becb9d4b630e4158540db683129b9fa7aecd451f
-rw-r--r-- 1 torrent torrent 12775 2008-10-01 04:24 ca2471e9e3a9a760f2772eada5e8cf04ff040209
-rw-r--r-- 1 torrent torrent  5612 2008-07-22 16:46 d3526923f3825c16f45d890f24e3758ab2053803
-rw-r--r-- 1 torrent torrent  5618 2008-07-22 16:46 d3aff05dea6b29167fe8ccf49005dd165aa10024
-rw-r--r-- 1 torrent torrent    50 2008-09-20 18:31 e232f7a91d9e4d1fe91f52ca3db01da6c4c7fc08
-rw-r--r-- 1 torrent torrent 27408 2008-07-22 16:46 e69f3c3f3b4990091ff319e66f47a3c29ead5bf9
-rw-r--r-- 1 torrent torrent    50 2008-09-20 23:27 f2270939cce71d3c1f6cc3180ff14a46666736b3
-rw-r--r-- 1 torrent torrent  5578 2008-10-12 14:52 f7abd8ab7d836ee7e34fdaa3c5f485abf46b3bea
Comment 7 Jeroen van Meeuwen 2008-10-17 06:23:03 EDT
By accident, it turns out this is still extremely current, using bittorrent-4.4.0-6.fc9.noarch
Comment 8 Paul Howarth 2008-10-17 06:58:14 EDT
Is this the same machine, or a different one running F-9?
Comment 9 Jeroen van Meeuwen 2008-10-17 08:21:08 EDT
Sorry, this is the same machine (hardware) upgraded to F-9
Comment 10 Jeroen van Meeuwen 2008-12-17 20:02:44 EST
Upgraded to F-10, problem still exists. I'm bumping the priority.
Comment 11 Oleg Aprotskiy 2009-04-01 16:13:43 EDT
Created attachment 337645 [details]
Fix bug with error: KeyError: <type 'float'>
Comment 12 Fedora Update System 2009-04-06 11:05:30 EDT
bittorrent-4.4.0-11.fc10 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/bittorrent-4.4.0-11.fc10
Comment 13 Fedora Update System 2009-04-06 11:06:55 EDT
bittorrent-4.4.0-11.fc9 has been submitted as an update for Fedora 9.
http://admin.fedoraproject.org/updates/bittorrent-4.4.0-11.fc9
Comment 14 Paul Howarth 2009-04-06 11:11:27 EDT
Thanks for the patch Oleg. I've applied that and a separate one for the original issue that I *think* should fix it. I did manage to reproduce it today (at last!) and it didn't happen with the patches applied.

Feedback on the update would be greatly appreciated.
Comment 15 Fedora Update System 2009-04-06 16:29:32 EDT
bittorrent-4.4.0-11.fc10 has been pushed to the Fedora 10 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update bittorrent'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F10/FEDORA-2009-3350
Comment 16 Fedora Update System 2009-04-06 16:35:08 EDT
bittorrent-4.4.0-11.fc9 has been pushed to the Fedora 9 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing-newkey update bittorrent'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F9/FEDORA-2009-3397
Comment 17 Fedora Update System 2009-05-07 04:55:15 EDT
bittorrent-4.4.0-12.fc10 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/bittorrent-4.4.0-12.fc10
Comment 18 Fedora Update System 2009-05-07 04:57:54 EDT
bittorrent-4.4.0-12.fc9 has been submitted as an update for Fedora 9.
http://admin.fedoraproject.org/updates/bittorrent-4.4.0-12.fc9
Comment 19 Fedora Update System 2009-05-09 00:03:19 EDT
bittorrent-4.4.0-12.fc10 has been pushed to the Fedora 10 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update bittorrent'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F10/FEDORA-2009-4411
Comment 20 Bug Zapper 2009-06-09 21:37:35 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 21 Bug Zapper 2009-07-15 04:21:07 EDT
Fedora 9 changed to end-of-life (EOL) status on 2009-07-10. Fedora 9 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 22 Paul Howarth 2009-07-15 05:08:30 EDT
Reopening as issue still reported to be present in F-10. Feedback on the update in the testing repository would be appreciated.
Comment 23 Fedora Update System 2009-10-27 03:06:34 EDT
bittorrent-4.4.0-12.fc10 has been pushed to the Fedora 10 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.